unit u_fotbal;

interface

uses
  SysUtils, Types, Classes, Variants, QGraphics, QControls, QForms, QDialogs,
  QExtCtrls, QStdCtrls, QComCtrls, QTypes, QMenus, QButtons,
  OpStr, MujDial, u_help;

const
  Pocet=24;                      //maximalni pocet tymu
  PKol=((Pocet-1) div 2)*2+1;    //pocet kol
  PZap=(Pocet+1) div 2;          //pocet zapasu za kolo

type
  TTym=string[30];                               //nazev tymu
  TSeznam=array [1..Pocet] of TTym;                //seznam tymu
  TZapasy=array [1..Pocet,1..Pocet] of integer;    //vysledky zapasu
  TSoubor=record                                 //struktura souboru
    poc:byte;                                      //pocet tymu
    sez:TSeznam;                                   //seznam tymu
    zap:TZapasy;                                   //vysledky zapasu
    end;
  TRozpis=array [1..PKol,1..PZap,1..2] of byte;   //rozpis zapasu
  TRadek=record                                 //radek tabulky
    cislo:byte;                                   //cislo tymu
    tym:TTym;                                     //nazev tymu
    pv,pr,pp:byte;                                //pocet vitezstvi, remiz, porazek
    bv,bo:integer;                                //vstrelene, obdrzene branky
    korekce:integer;                              //korekce
    body:integer;                                 //pocet bodu
    dodatek:boolean;                              //skryt poradi
    bvc,boc:integer;                              //vstrelene, obdrzene branky celkem - pro minitabulku
    end;
  TTabulka=array [1..Pocet] of TRadek;            //tabulka

  TForm1 = class(TForm)
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Memo1: TMemo;
    Button1: TButton;
    CheckBox1: TCheckBox;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Edit2: TEdit;
    Edit3: TEdit;
    Button4: TButton;
    CheckBox2: TCheckBox;
    Label8: TLabel;
    Edit4: TEdit;
    ComboBox3: TComboBox;
    ListBox1: TListBox;
    Edit5: TEdit;
    Edit6: TEdit;
    Button7: TButton;
    ComboBox4: TComboBox;
    Edit7: TEdit;
    Button8: TButton;
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Nov1: TMenuItem;
    Otevt1: TMenuItem;
    Uloit1: TMenuItem;
    Uloitjako1: TMenuItem;
    N1: TMenuItem;
    Konec1: TMenuItem;
    Menumemo1: TMenuItem;
    Uloit2: TMenuItem;
    Zavt1: TMenuItem;
    Npovda1: TMenuItem;
    Obsah1: TMenuItem;
    Oprogramu1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    SaveDialog2: TSaveDialog;
    HTML1: TMenuItem;
    SaveDialog3: TSaveDialog;
    Operace1: TMenuItem;
    N1Tmy1: TMenuItem;
    N2Rozpis1: TMenuItem;
    N31: TMenuItem;
    N41: TMenuItem;
    N51: TMenuItem;
    N61: TMenuItem;
    N71: TMenuItem;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    SpinEdit1: TSpinEdit;
    procedure FormCreate(Sender: TObject);
    procedure Label1Click(Sender: TObject);
    procedure Label2Click(Sender: TObject);
    procedure Label3Click(Sender: TObject);
    procedure Label4Click(Sender: TObject);
    procedure Label5Click(Sender: TObject);
    procedure Label6Click(Sender: TObject);
    procedure Label7Click(Sender: TObject);
    procedure Label1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure ComboBox1Click(Sender: TObject);
    procedure ComboBox2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ComboBox3Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure ComboBox4Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Nov1Click(Sender: TObject);
    procedure Otevt1Click(Sender: TObject);
    procedure Uloit1Click(Sender: TObject);
    procedure Uloitjako1Click(Sender: TObject);
    procedure Konec1Click(Sender: TObject);
    procedure Uloit2Click(Sender: TObject);
    procedure Zavt1Click(Sender: TObject);
    procedure Obsah1Click(Sender: TObject);
    procedure Oprogramu1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HTML1Click(Sender: TObject);
    procedure N1Tmy1Click(Sender: TObject);
    procedure N2Rozpis1Click(Sender: TObject);
    procedure N31Click(Sender: TObject);
    procedure N41Click(Sender: TObject);
    procedure N51Click(Sender: TObject);
    procedure N61Click(Sender: TObject);
    procedure N71Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure SpinEdit1Changed(Sender: TObject; NewValue: Integer);
  private
    { Private declarations }
    Seznam:TSeznam;            //seznam tymu
    Rozpis:TRozpis;            //rozpis zapasu
    Zapasy:TZapasy;            //vysledky zapasu
    SPocet,SPKol,SPZap:byte;   //skutecny pocet tymu, kol, zapasu za kolo
    Zmena:boolean;             //zmena projektu
    Jmeno:string;              //nazev projektu
    TabHTML:TTabulka;          //tabulka pro export do HTML
    procedure NastavEdit(kolo,zapas:byte);
    procedure NastavEditDve(t1,t2:byte);
    function VratPozici(tym:TTym):byte;
    procedure SestavTabulku;
    procedure Trideni(var tab:TTabulka;zac,kon:byte);
    procedure Refresh;
    procedure RefreshLabel;
    procedure RefreshMenu(pol:byte);
    procedure PoleInit;
    procedure Zmeneno;
    procedure Nadpis;
    procedure Ulozeni;
    procedure UlozeniJako;
    function Muzuprovest:boolean;
    function Vysledek(z1,z2:integer):string;
    function MojeIntToStr(x:integer):string;
    procedure MojeStrToInt(var s1,s2:string;var x1,x2:integer);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.xfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
//po spusteni
Refresh;
RefreshLabel;
RefreshMenu(2);
SPocet:=2;
Seznam[1]:='Tym1';
Seznam[2]:='Tym2';
Zapasy[1,1]:=0;
Zapasy[2,2]:=0;
Zapasy[1,2]:=-1;
Zapasy[2,1]:=-1;
Form1.Caption:='Fotbal: novy';
Zmena:=False;
Jmeno:='';
PoleInit;
end;

procedure TForm1.Label1Click(Sender: TObject);
//seznam tymu
var i:byte;
begin
Refresh;
SaveDialog2.FileName:='noname.txt';
Menumemo1.Caption:='&Tymy';
HTML1.Visible:=False;
RefreshMenu(3);
HTML1.Tag:=1;
Memo1.Clear;
Memo1.Height:=305;
for i:=1 to SPocet do
  Memo1.Lines.Add(Seznam[i]);
Memo1.Show;
Button1.Show;
end;

procedure TForm1.Label2Click(Sender: TObject);
//rozpis zapasu
var i,j:byte;
    s,v:string;
begin
Refresh;
SaveDialog2.FileName:='noname.txt';
Menumemo1.Caption:='&Rozpis';
HTML1.Visible:=True;
RefreshMenu(3);
HTML1.Tag:=2;
Memo1.Clear;
for i:=1 to SPkol do
  begin
  Memo1.Lines.Add(IntToStr(i)+'. kolo');
  if ((Rozpis[i,1,1]<>0) and (Rozpis[i,1,2]<>0)) then
    begin
    s:=Leftstr(Seznam[Rozpis[i,1,1]]+'                    ',20)+' - ';
    s:=s+LeftStr(Seznam[Rozpis[i,1,2]]+'                    ',20)+'   ';
    v:=Vysledek(Zapasy[Rozpis[i,1,1],Rozpis[i,1,2]],Zapasy[Rozpis[i,1,2],Rozpis[i,1,1]]);
    s:=s+RightStr('     '+v,Length(v)-Pos(':',v)+6);
    Memo1.Lines.Add(s);
    end;
  for j:=2 to SPZap do
    begin
    s:=LeftStr(Seznam[Rozpis[i,j,1]]+'                    ',20)+' - ';
    s:=s+LeftStr(Seznam[Rozpis[i,j,2]]+'                    ',20)+'   ';
    v:=Vysledek(Zapasy[Rozpis[i,j,1],Rozpis[i,j,2]],Zapasy[Rozpis[i,j,2],Rozpis[i,j,1]]);
    s:=s+RightStr('     '+v,Length(v)-Pos(':',v)+6);
    Memo1.Lines.Add(s);
    end;
  Memo1.Lines.Add('');
  end;
Memo1.Show;
end;

procedure TForm1.Label3Click(Sender: TObject);
//vypis tabulky
begin
Refresh;
Memo1.Clear;
CheckBox1.Enabled:=False;
CheckBox1.Checked:=True;
SestavTabulku;
CheckBox1.Enabled:=True;
SaveDialog2.FileName:='noname.txt';
Menumemo1.Caption:='&Tabulka';
HTML1.Visible:=True;
RefreshMenu(3);
HTML1.Tag:=3;
Memo1.Height:=305;
CheckBox1.Show;
Memo1.Show;
end;

procedure TForm1.Label4Click(Sender: TObject);
var i:byte;
begin
//vysledky po kolech
Refresh;
RefreshMenu(2);
SpinEdit1.Value:=1;
ComboBox1.Items.Clear;
ComboBox2.Items.Clear;
for i:=1 to SPZap do
  begin
  ComboBox1.Items.Add(Seznam[Rozpis[1,i,1]]);
  ComboBox2.Items.Add(Seznam[Rozpis[1,i,2]]);
  end;
ComboBox1.ItemIndex:=0;
ComboBox2.ItemIndex:=0;
NastavEdit(1,1);
Label8.Top:=128;
Label8.Show;
SpinEdit1.Show;
Button4.Show;
CheckBox2.Show;
Edit2.Show;
Edit3.Show;
ComboBox1.Show;
ComboBox2.Show;
end;

procedure TForm1.Label5Click(Sender: TObject);
var i:byte;
    b:boolean;
begin
//vysledky po tymech
Refresh;
RefreshMenu(2);
ComboBox3.Items.Clear;
ListBox1.Items.Clear;
b:=CheckBox3.Checked;
ComboBox3.Sorted:=b;
ListBox1.Sorted:=b;
for i:=1 to SPocet do
  begin
  ComboBox3.Items.Add(Seznam[i]);
  ListBox1.Items.Add(Seznam[i]);
  end;
ComboBox3.ItemIndex:=0;
ListBox1.Items.Delete(0);
ListBox1.ItemIndex:=0;
NastavEditDve(VratPozici(ComboBox3.Items[0]),VratPozici(ListBox1.Items[0]));
Label8.Top:=264;
Label8.Show;
Edit4.Show;
Button7.Show;
Edit5.Show;
Edit6.Show;
ComboBox3.Show;
ListBox1.Show;
CheckBox3.Show;
end;

procedure TForm1.Label6Click(Sender: TObject);
//korekce
var t1,i:byte;
begin
Refresh;
RefreshMenu(2);
ComboBox4.Items.Clear;
ComboBox4.Sorted:=CheckBox4.Checked;
for i:=1 to SPocet do
  ComboBox4.Items.Add(Seznam[i]);
ComboBox4.ItemIndex:=0;
t1:=VratPozici(ComboBox4.Items[0]);
Edit7.Text:=IntToStr(Zapasy[t1,t1]);
ComboBox4.Show;
CheckBox4.Show;
Button8.Show;
Edit7.Show;
end;

procedure TForm1.Label7Click(Sender: TObject);
//krizova tabulka
var i,j:byte;
    s,v,r:string;
begin
Refresh;
Memo1.Clear;
r:='+----------------------+';
for i:=1 to SPocet do
  r:=r+'------------+';
Memo1.Lines.Add(r);
s:='|                      |';
for i:=1 to SPocet do
  begin
  s:=s+' ';
  s:=s+LeftStr(Seznam[i]+'          ',10);
  s:=s+' |';
  end;
Memo1.Lines.Add(s);
Memo1.Lines.Add(r);
for i:=1 to SPocet do
  begin
  s:='| ';
  s:=s+LeftStr(Seznam[i]+'                    ',20);
  s:=s+' |';
  for j:=1 to SPocet do
    if i<>j then begin
                 v:=Vysledek(Zapasy[i,j],Zapasy[j,i]);
                 v:=RightStr('     '+v,Length(v)-Pos(':',v)+6);
                 v:=LeftStr(v+'            ',12);
                 s:=s+v+'|';
                 end
            else s:=s+' xxxxxxxxxx |';
  Memo1.Lines.Add(s);
  Memo1.Lines.Add(r);
  end;
SaveDialog2.FileName:='noname.txt';
Menumemo1.Caption:='&Krizova tabulka';
HTML1.Visible:=True;
RefreshMenu(3);
HTML1.Tag:=4;
Memo1.ScrollBars:=ssBoth;
Memo1.Show;
end;

procedure TForm1.Label1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
//stisk mysi na labelech
begin
if Button=mbLeft then
  (Sender as TLabel).Font.Color:=clRed;
end;

procedure TForm1.Label1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
//uvolneni mysi na labelech
begin
if Button=mbLeft then
  (Sender as TLabel).Font.Color:=clNavy;
end;

procedure TForm1.Button1Click(Sender: TObject);
//zmena tymu
var n,i,j:byte;
    b:boolean;
begin
n:=Memo1.Lines.Count;
if n<2 then
  MujDialog('Chybne zadani:'+Chr(10)+'malo tymu', [mdStorno], tdCHY)
else
  if n>Pocet then
    MujDialog('Chybne zadani:'+Chr(10)+'moc tymu', [mdStorno], tdCHY)
  else
    begin
    b:=False;
    for i:=1 to (n-1) do
      for j:=(i+1) to n do
        if Memo1.Lines[i-1]=Memo1.Lines[j-1] then b:=True;
    if b then MujDialog('Chybne zadani:'+Chr(10)+'duplicitni nazev', [mdStorno], tdCHY)
         else begin
              if n<>SPocet then
                begin
                SPocet:=n;
                PoleInit;
                b:=True;
                end
              else
                b:=mdAno=MujDialog('Zmena nazvu tymu,'+Chr(10)+'mam vymazat vysledky?', [mdAno, mdNe], tdPOT);
              if b then
                for i:=1 to SPocet do
                  begin
                  for j:=1 to SPocet do
                    Zapasy[i,j]:=-1;
                  Zapasy[i,i]:=0;
                  end;
              for i:=1 to SPocet do
                Seznam[i]:=Memo1.Lines[i-1];
              Zmeneno;
              end;
    end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
//zmena tvaru tabulky
begin
if CheckBox1.Enabled then
  begin
  Memo1.Clear;
  SestavTabulku;
  end;
end;

procedure TForm1.SpinEdit1Changed(Sender: TObject; NewValue: Integer);
//zmena kola
var i:byte;
begin
ComboBox1.Items.Clear;
ComboBox2.Items.Clear;
for i:=1 to SPZap do
  begin
  ComboBox1.Items.Add(Seznam[Rozpis[SpinEdit1.Value,i,1]]);
  ComboBox2.Items.Add(Seznam[Rozpis[SpinEdit1.Value,i,2]]);
  end;
ComboBox1.ItemIndex:=0;
ComboBox2.ItemIndex:=0;
NastavEdit(SpinEdit1.Value,ComboBox1.ItemIndex+1);
end;


procedure TForm1.ComboBox1Click(Sender: TObject);

//zmena domaciho tymu
begin
ComboBox2.ItemIndex:=ComboBox1.ItemIndex;
NastavEdit(SpinEdit1.Value,ComboBox1.ItemIndex+1);
end;

procedure TForm1.ComboBox2Click(Sender: TObject);
//zmena hostujiciho tymu
begin
ComboBox1.ItemIndex:=ComboBox2.ItemIndex;
NastavEdit(SpinEdit1.Value,ComboBox1.ItemIndex+1);
end;

procedure TForm1.Button4Click(Sender: TObject);
//vysledek zapasu
var z1,z2:integer;
    s1,s2:string;
begin
s1:=Edit2.Text;
s2:=Edit3.Text;
MojeStrToInt(s1,s2,z1,z2);
Edit2.Text:=s1;
Edit3.Text:=s2;
Zapasy[Rozpis[SpinEdit1.Value,ComboBox1.ItemIndex+1,1],Rozpis[SpinEdit1.Value,ComboBox1.ItemIndex+1,2]]:=z1;
Zapasy[Rozpis[SpinEdit1.Value,ComboBox1.ItemIndex+1,2],Rozpis[SpinEdit1.Value,ComboBox1.ItemIndex+1,1]]:=z2;
if ((ComboBox1.ItemIndex<(ComboBox1.Items.Count-1)) and CheckBox2.Checked) then
  begin
  ComboBox1.ItemIndex:=ComboBox1.ItemIndex+1;
  ComboBox2.ItemIndex:=ComboBox1.ItemIndex;
NastavEdit(SpinEdit1.Value,ComboBox1.ItemIndex+1);
  end;
Zmeneno;
end;

procedure TForm1.ComboBox3Click(Sender: TObject);
//zmena tymu
var i:byte;
begin
ListBox1.Clear;
for i:=1 to SPocet do
  ListBox1.Items.Add(Seznam[i]);
ListBox1.Items.Delete(ComboBox3.ItemIndex);
ListBox1.ItemIndex:=0;
NastavEditDve(VratPozici(ComboBox3.Items[ComboBox3.ItemIndex]),VratPozici(ListBox1.Items[0]));
end;

procedure TForm1.ListBox1Click(Sender: TObject);
//zmena soupere
begin
NastavEditDve(VratPozici(ComboBox3.Items[ComboBox3.ItemIndex]),VratPozici(ListBox1.Items[ListBox1.ItemIndex]));
end;

procedure TForm1.Button7Click(Sender: TObject);
//vysledek zapasu
var t1,t2:byte;
    z1,z2:integer;
    s1,s2:string;
begin
t1:=VratPozici(ComboBox3.Items[ComboBox3.ItemIndex]);
t2:=VratPozici(ListBox1.Items[ListBox1.ItemIndex]);
s1:=Edit5.Text;
s2:=Edit6.Text;
MojeStrToInt(s1,s2,z1,z2);
Edit5.Text:=s1;
Edit6.Text:=s2;
Zapasy[t1,t2]:=z1;
Zapasy[t2,t1]:=z2;
Zmeneno;
end;

procedure TForm1.ComboBox4Click(Sender: TObject);
//zmena tymu
var t1:byte;
begin
t1:=VratPozici(ComboBox4.Items[ComboBox4.ItemIndex]);
Edit7.Text:=IntToStr(Zapasy[t1,t1]);
end;

procedure TForm1.Button8Click(Sender: TObject);
//zmena korekce
var t1:byte;
begin
t1:=VratPozici(ComboBox4.Items[ComboBox4.ItemIndex]);
try
  Zapasy[t1,t1]:=StrToInt(Edit7.Text);
except
  on EConvertError do
    Edit7.Text:=IntToStr(Zapasy[t1,t1]);
end;
Zmeneno;
end;

procedure TForm1.Nov1Click(Sender: TObject);
begin
if MuzuProvest then
  begin
  Refresh;
  RefreshLabel;
  RefreshMenu(2);
  SPocet:=2;
  Seznam[1]:='Tym1';
  Seznam[2]:='Tym2';
  Zapasy[1,1]:=0;
  Zapasy[2,2]:=0;
  Zapasy[1,2]:=-1;
  Zapasy[2,1]:=-1;
  Form1.Caption:='Fotbal: novy';
  Zmena:=False;
  Jmeno:='';
  PoleInit;
  end;
end;

procedure TForm1.Otevt1Click(Sender: TObject);
//otevreni projektu
var x:TSoubor;
    f:file of TSoubor;
begin
if MuzuProvest then
  begin
  OpenDialog1.FileName:='noname.fp';
  if OpenDialog1.Execute then
    begin
    Refresh;
    RefreshLabel;
    RefreshMenu(2);
    AssignFile(f,OpenDialog1.FileName);
    Reset(f);
    Read(f,x);
    CloseFile(f);
    SPocet:=x.poc;
    Seznam:=x.sez;
    Zapasy:=x.zap;
    Nadpis;
    Zmena:=False;
    PoleInit;
    end;
  end;
end;

procedure TForm1.Uloit1Click(Sender: TObject);
//ulozeni projektu
begin
if Jmeno='' then UlozeniJako
            else Ulozeni;
end;

procedure TForm1.Uloitjako1Click(Sender: TObject);
//ulozeni projektu pod jmenem
begin
UlozeniJako;
end;

procedure TForm1.Konec1Click(Sender: TObject);
//konec programu
begin
Close;
end;

procedure TForm1.Uloit2Click(Sender: TObject);
//ulozeni mema
begin
if SaveDialog2.Execute then
  Memo1.Lines.SaveToFile(SaveDialog2.FileName);
end;

procedure TForm1.Zavt1Click(Sender: TObject);
//zavreni mema
begin
Refresh;
RefreshMenu(2);
end;

procedure TForm1.Obsah1Click(Sender: TObject);
//napoveda
begin
HelpForm.ShowHelp(-1);
end;

procedure TForm1.Oprogramu1Click(Sender: TObject);
//informace o programu
var s:string;
begin
s:='Program Fotbal v2.1 Kylix';
s:=s+Chr(10)+'by Jan Posta';
s:=s+Chr(10)+'(c) PostWare 2000-2001';
s:=s+Chr(10)+'postware@postak.com';
s:=s+Chr(10)+'http://vanous.postak.com';
MujDialog(s,[mdOK],tdINF);
end;

procedure TForm1.NastavEdit(kolo,zapas:byte);
//nastaveni editu
begin
Edit2.Text:=MojeIntToStr(Zapasy[Rozpis[kolo,zapas,1],Rozpis[kolo,zapas,2]]);
Edit3.Text:=MojeIntToStr(Zapasy[Rozpis[kolo,zapas,2],Rozpis[kolo,zapas,1]]);
end;

procedure TForm1.NastavEditDve(t1,t2:byte);
//nastaveni editu
var i,j,k:byte;
begin
k:=0;
i:=1;
j:=1;
repeat
  if (((Rozpis[i,j,1]=t1) and (Rozpis[i,j,2]=t2)) or ((Rozpis[i,j,1]=t2) and (Rozpis[i,j,2]=t1))) then k:=i;
  if j=SPZap then
    begin
    j:=1;
    i:=i+1;
    end
  else
    j:=j+1;
until k<>0;
Edit4.Text:=IntToStr(k);
Edit5.Text:=MojeIntToStr(Zapasy[t1,t2]);
Edit6.Text:=MojeIntToStr(Zapasy[t2,t1]);
end;

function TForm1.VratPozici(tym:TTym):byte;
//cislo tymu podle jmena
var x:byte;
begin
x:=1;
while Seznam[x]<>tym do
  x:=x+1;
Result:=x;
end;

procedure TForm1.SestavTabulku;
//sestaveni tabulky

function Sgn(x:integer):shortint;
begin
if x=0 then Result:=0
       else Result:=x div abs(x);
end;

procedure Minitabulka(var tabx:TTabulka;i,mini:byte);forward;

procedure HledejChybu(var tab:TTabulka;zu,ku:byte);
var i,mini:byte;
begin
i:=zu;
mini:=0;
while i<ku do
  begin
  if tab[i].body=tab[i+1].body then
    mini:=mini+1
  else
    if mini>0 then
      begin
      Minitabulka(tab,i,mini);
      mini:=0;
      end;
  i:=i+1;
  end;
if mini>0 then
  Minitabulka(tab,i,mini);
end;

procedure Minitabulka(var tabx:TTabulka;i,mini:byte);
var minitab:TTabulka;
    mn:set of byte;
    j,k:byte;
    z1,z2:integer;
    x:TRadek;
begin
mn:=[];
for j:=1 to (mini+1) do
  mn:=mn+[tabx[i-mini+j-1].cislo];
for j:=1 to (mini+1) do
  begin
  minitab[j].cislo:=tabx[i-mini+j-1].cislo;
  minitab[j].pv:=0;
  minitab[j].pr:=0;
  minitab[j].pp:=0;
  minitab[j].bv:=0;
  minitab[j].bo:=0;
  minitab[j].bvc:=tabx[i-mini+j-1].bvc;
  minitab[j].boc:=tabx[i-mini+j-1].boc;
  minitab[j].dodatek:=False;
  minitab[j].body:=0;
  for k:=1 to SPocet do
    if (k in mn) then
      begin
      z1:=Zapasy[minitab[j].cislo,k];
      z2:=Zapasy[k,minitab[j].cislo];
      if z1>0 then minitab[j].bv:=minitab[j].bv+z1;
      if z2>0 then minitab[j].bo:=minitab[j].bo+z2;
      if ((z1=-6) and (z2=-6)) then
        begin
        minitab[j].pp:=minitab[j].pp+1;
        minitab[j].bo:=minitab[j].bo+6;
        end
      else
        if z1<>-1 then
          case Sgn(z1-z2) of
             1:minitab[j].pv:=minitab[j].pv+1;
             0:minitab[j].pr:=minitab[j].pr+1;
            -1:minitab[j].pp:=minitab[j].pp+1;
            end;
      end;
  minitab[j].body:=minitab[j].pv*2+minitab[j].pr;
  end;
Trideni(minitab,1,mini+1);
if minitab[1].body>minitab[mini+1].body then
  HledejChybu(minitab,1,mini+1)
else
  for j:=1 to mini do
    if (((minitab[j].bv=minitab[j+1].bv) and (minitab[j].bo=minitab[j+1].bo)) and
       ((minitab[j].bvc=minitab[j+1].bvc) and (minitab[j].boc=minitab[j+1].boc))) then
      minitab[j+1].dodatek:=True;
for j:=1 to (mini+1) do
  begin
  k:=1;
  while minitab[j].cislo<>tabx[i-mini+k-1].cislo do
    k:=k+1;
  x:=tabx[i-mini+j-1];
  tabx[i-mini+j-1]:=tabx[i-mini+k-1];
  tabx[i-mini+k-1]:=x;
  tabx[i-mini+j-1].dodatek:=minitab[j].dodatek;
  end;
end;

var i,j:byte;
    z1,z2:integer;
    s:string;
    tabulka:TTabulka;
begin
for i:=1 to SPocet do
  begin
  tabulka[i].cislo:=i;
  tabulka[i].tym:=Seznam[i];
  tabulka[i].pv:=0;
  tabulka[i].pr:=0;
  tabulka[i].pp:=0;
  tabulka[i].bv:=0;
  tabulka[i].bo:=0;
  tabulka[i].korekce:=Zapasy[i,i];
  tabulka[i].dodatek:=False;
  tabulka[i].body:=0;
  for j:=1 to SPocet do
    if j<>i then
      begin
      z1:=Zapasy[i,j];
      z2:=Zapasy[j,i];
      if z1>0 then tabulka[i].bv:=tabulka[i].bv+z1;
      if z2>0 then tabulka[i].bo:=tabulka[i].bo+z2;
      if ((z1=-6) and (z2=-6)) then
        begin
        tabulka[i].pp:=tabulka[i].pp+1;
        tabulka[i].bo:=tabulka[i].bo+6;
        end
      else
        if z1<>-1 then
          case Sgn(z1-z2) of
             1:tabulka[i].pv:=tabulka[i].pv+1;
             0:tabulka[i].pr:=tabulka[i].pr+1;
            -1:tabulka[i].pp:=tabulka[i].pp+1;
            end;
      end;
  tabulka[i].body:=tabulka[i].pv*2+tabulka[i].pr+tabulka[i].korekce;
  tabulka[i].bvc:=tabulka[i].bv;
  tabulka[i].boc:=tabulka[i].bo;
  end;
Trideni(tabulka,1,SPocet);
if not CheckBox1.Enabled then
  for i:=1 to SPocet do
    if ((tabulka[i].pv+tabulka[i].pr+tabulka[i].pp)<SPKol) then CheckBox1.Checked:=False;
if CheckBox1.Checked then
  HledejChybu(tabulka,1,SPocet)
else
  for i:=1 to (SPocet-1) do
    if ((tabulka[i].body=tabulka[i+1].body) and (tabulka[i].bv=tabulka[i+1].bv) and (tabulka[i].bo=tabulka[i+1].bo)) then
      tabulka[i+1].dodatek:=True;
for i:=1 to SPocet do
  begin
  if tabulka[i].dodatek then s:='     '
                        else s:=LeftStr(IntToStr(i)+'.    ',5);
  s:=s+LeftStr(tabulka[i].tym+'                    ',20);
  s:=s+RightStr('    '+IntToStr(tabulka[i].pv+tabulka[i].pr+tabulka[i].pp),4);
  s:=s+RightStr('    '+IntToStr(tabulka[i].pv),4);
  s:=s+RightStr('    '+IntToStr(tabulka[i].pr),4);
  s:=s+RightStr('    '+IntToStr(tabulka[i].pp),4);
  s:=s+RightStr('      '+IntToStr(tabulka[i].bv)+':',7);
  s:=s+LeftStr(IntToStr(tabulka[i].bo)+'     ',5);
  s:=s+RightStr('    '+IntToStr(tabulka[i].body),4);
  Memo1.Lines.Add(s);
  end;
TabHTML:=tabulka;
end;

procedure TForm1.Trideni(var tab:TTabulka;zac,kon:byte);
//trideni tabulky

function Vyhodnot(h1,h2:TRadek):boolean;
//vracim True, jestlize h1 ma byt pred h2
//h1 je pred h2 jestlize:
//-h1 ma vic bodu
//-h1 ma stejne bodu, ale lepsi rozdil skore
//-h1 ma stejne bodu, stejny rozdil skore, ale vice vstrelenych branek
//-h1 ma stejne bodu, stejny rozdil skore, stejne vstrelenych branek, ale je drive v seznamu tymu
//atd.
var b:boolean;
begin
//Result:=((h1.body>h2.body) or ((h1.body=h2.body) and ((h1.bv-h1.bo)>(h2.bv-h2.bo))) or ((h1.body=h2.body) and ((h1.bv-h1.bo)=(h2.bv-h2.bo)) and (h1.bv>h2.bv)) or ((h1.body=h2.body) and ((h1.bv-h1.bo)=(h2.bv-h2.bo)) and (h1.bv=h2.bv) and (h1.cislo<h2.cislo))); atd.   ... jina moznost
//prehledneji:
b:=False;
if h1.body>h2.body then
  b:=True
else
  if h1.body=h2.body then
    if (h1.bv-h1.bo)>(h2.bv-h2.bo) then
      b:=True
    else
      if (h1.bv-h1.bo)=(h2.bv-h2.bo) then
        if h1.bv>h2.bv then
          b:=True
        else
          if h1.bv=h2.bv then
            if (h1.bvc-h1.boc)>(h2.bvc-h2.boc) then
              b:=True
            else
              if (h1.bvc-h1.boc)=(h2.bvc-h2.boc) then
                if h1.bvc>h2.bvc then
                  b:=True
                else
                  if h1.cislo<h2.cislo then
                    b:=True;
Result:=b;
end;

var x,q:tradek;
    i,j:byte;
begin
i:=zac;
j:=kon;
x:=tab[(zac+kon) div 2];
repeat
  while Vyhodnot(tab[i],x) do i:=i+1;
  while Vyhodnot(x,tab[j]) do j:=j-1;
  if i<j then
    begin
    q:=tab[i];
    tab[i]:=tab[j];
    tab[j]:=q;
    i:=i+1;
    j:=j-1;
    end
  else
    if i=j then
      begin
      i:=i+1;
      j:=j-1;
      end;
  until i>j;
  if zac<j then Trideni(tab,zac,j);
  if i<kon then Trideni(tab,i,kon);
end;

procedure TForm1.Refresh;
//obnoveni formulare
begin
Memo1.Hide;
Button1.Hide;
Button4.Hide;
Button7.Hide;
Button8.Hide;
Edit2.Hide;
Edit3.Hide;
Edit4.Hide;
Edit5.Hide;
Edit6.Hide;
Edit7.Hide;
ComboBox1.Hide;
ComboBox2.Hide;
ComboBox3.Hide;
ComboBox4.Hide;
SpinEdit1.Hide;
ListBox1.Hide;
CheckBox1.Hide;
CheckBox2.Hide;
CheckBox3.Hide;
CheckBox4.Hide;
Label8.Hide;
Memo1.ScrollBars:=ssVertical;
Memo1.Height:=353;
end;

procedure TForm1.RefreshLabel;
//obnoveni labelu
begin
Label1.Font.Color:=clBlue;
Label2.Font.Color:=clBlue;
Label3.Font.Color:=clBlue;
Label4.Font.Color:=clBlue;
Label5.Font.Color:=clBlue;
Label6.Font.Color:=clBlue;
Label7.Font.Color:=clBlue;
end;

procedure TForm1.RefreshMenu(pol:byte);
begin
if pol=2 then Menumemo1.Visible:=False
         else Menumemo1.Visible:=True;
end;

procedure TForm1.PoleInit;
//vytvoreni rozpisu
var i,j,c:byte;
begin
SPKol:=((SPocet-1) div 2)*2+1;
SPZap:=(SPocet+1) div 2;
SpinEdit1.Max:=SPKol;
c:=1;
for i:=1 to SPKol do
  for j:=1 to SPZap do
    begin
    Rozpis[i,j,1]:=c;
    c:=(c mod SPKol)+1;
    end;
c:=1;
for i:=SPkol downto 1 do
  for j:=SPZap downto 2 do
    begin
    Rozpis[i,j,2]:=c;
    c:=(c mod SPKol)+1;
    end;
if Odd(SPocet) then c:=0
               else c:=SPocet;
for i:=1 to SPKol do
  if Odd(i) then Rozpis[i,1,2]:=c
            else begin
                 Rozpis[i,1,2]:=Rozpis[i,1,1];
                 Rozpis[i,1,1]:=c;
                 end;
end;

procedure TForm1.Zmeneno;
//zmena v projektu
begin
if not Zmena then
  begin
  Zmena:=True;
  Form1.Caption:=Form1.Caption+' (zmeneno)';
  end;
end;

procedure TForm1.Nadpis;
//nadpis formulare
var i,j:integer;
begin
i:=1;
while (AtStr('\',OpenDialog1.FileName,i)>0) do
  i:=i+1;
j:=1;
while (AtStr('.',OpenDialog1.FileName,j)>0) do
  j:=j+1;
Jmeno:=Copy(OpenDialog1.FileName,AtStr('\',OpenDialog1.FileName,i-1)+1,AtStr('.',OpenDialog1.FileName,j-1)-AtStr('\',OpenDialog1.FileName,i-1)-1);
Form1.Caption:='Fotbal: '+Jmeno;
end;

procedure TForm1.Ulozeni;
//ulozeni projektu
var x:TSoubor;
    f:file of TSoubor;
begin
x.poc:=SPocet;
x.sez:=Seznam;
x.zap:=Zapasy;
AssignFile(f,OpenDialog1.FileName);
Rewrite(f);
Write(f,x);
CloseFile(f);
Nadpis;
Zmena:=False;
end;

procedure TForm1.UlozeniJako;
//ulozeni projektu podle jmena
var x:TSoubor;
    f:file of TSoubor;
begin
SaveDialog1.FileName:='noname.fp';
if SaveDialog1.Execute then
  begin
  x.poc:=SPocet;
  x.sez:=Seznam;
  x.zap:=Zapasy;
  AssignFile(f,SaveDialog1.FileName);
  Rewrite(f);
  Write(f,x);
  CloseFile(f);
  OpenDialog1.FileName:=SaveDialog1.FileName;
  Nadpis;
  Zmena:=False;
  end;
end;

function TForm1.MuzuProvest:boolean;
//pred zavrenim projektu
var b:boolean;
begin
b:=False;
if Zmena then
  case MujDialog('Projekt byl zmenen, ulozit?', [mdAno, mdNe, mdStorno], tdVAR) of
    mdAno:begin
          if Jmeno='' then UlozeniJako
                      else Ulozeni;
          b:=True;
          end;
    mdNe:b:=True;
    end
else
  b:=True;
Result:=b;
end;

function TForm1.Vysledek(z1,z2:integer):string;
//format vysledku
begin
if ((z1=-6) and (z2=-6)) then
  Result:='-:- k'
else
  if z1=-6 then
    Result:='0:6 k'
  else
    if z2=-6 then
      Result:='6:0 k'
    else
      if z1=-1 then
        Result:=''
      else
        Result:=IntToStr(z1)+':'+IntToStr(z2);
end;

function TForm1.MojeIntToStr(x:integer):string;
//prevod cisla na text
begin
if x=-6 then
  Result:='k'
else
  if x=-1 then
    Result:=''
  else
    Result:=IntToStr(x);
end;

procedure TForm1.MojeStrToInt(var s1,s2:string;var x1,x2:integer);
//prevod textu na cisla
begin
if ((Length(s1)=1) and (UpCase(s1[1])='K') and (Length(s2)=1) and (UpCase(s2[1])='K')) then
  begin
  x1:=-6;
  x2:=-6;
  s1:='k';
  s2:='k';
  end
else
  if ((Length(s1)=1) and (UpCase(s1[1])='K')) then
    begin
    x1:=-6;
    x2:=6;
    s1:='k';
    s2:='6';
    end
  else
    if ((Length(s2)=1) and (UpCase(s2[1])='K')) then
      begin
      x1:=6;
      x2:=-6;
      s1:='6';
      s2:='k';
      end
    else
      begin
      try
        x1:=StrToInt(s1);
        x2:=StrToInt(s2);
        if ((x1<0) or (x2<0)) then
          begin
          x1:=-1;
          x2:=-1;
          s1:='';
          s2:='';
          end;
      except
        on EConvertError do
            begin
            x1:=-1;
            x2:=-1;
            s1:='';
            s2:='';
            end;
      end;
      end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
//konec programu
begin
if MuzuProvest then Action:=caFree
               else Action:=caNone;
end;

procedure TForm1.HTML1Click(Sender: TObject);
//HTML vystup
var f:TextFile;
    i,j:integer;
    v,vl,vr:string;
begin
SaveDialog3.FileName:='noname.htm';
if SaveDialog3.Execute then
  begin
  AssignFile(f,SaveDialog3.FileName);
  Rewrite(f);
  writeln(f);
  writeln(f,'<!-- BeginSource           -->');
  writeln(f);
  writeln(f,'<!-- generated by PostWare -->');
  writeln(f);
  case HTML1.Tag of
    2:begin
      writeln(f,'<FONT size="3">');
      writeln(f,'<TABLE border="0" cellspacing="5" cellpadding="1">');
      for i:=1 to SPkol do
        begin
        writeln(f,'  <TR height="35">');
        writeln(f,'    <TD width="220">');
        writeln(f,'      <B>'+IntToStr(i)+'. kolo</B>');
        writeln(f,'    </TD>');
        writeln(f,'    <TD width="10">');
        writeln(f,'    </TD>');
        writeln(f,'    <TD width="220">');
        writeln(f,'    </TD>');
        writeln(f,'    <TD width="40">');
        writeln(f,'    </TD>');
        writeln(f,'    <TD width="5">');
        writeln(f,'    </TD>');
        writeln(f,'    <TD width="60">');
        writeln(f,'    </TD>');
        writeln(f,'  </TR>');
        if ((Rozpis[i,1,1]<>0) and (Rozpis[i,1,2]<>0)) then
          begin
          writeln(f,'  <TR>');
          writeln(f,'    <TD align="left">');
          writeln(f,'      '+Seznam[Rozpis[i,1,1]]);
          writeln(f,'    </TD>');
          writeln(f,'    <TD align="center">');
          writeln(f,'      -');
          writeln(f,'    </TD>');
          writeln(f,'    <TD align="left">');
          writeln(f,'      '+Seznam[Rozpis[i,1,2]]);
          writeln(f,'    </TD>');
          v:=Vysledek(Zapasy[Rozpis[i,1,1],Rozpis[i,1,2]],Zapasy[Rozpis[i,1,2],Rozpis[i,1,1]]);
          if v<>'' then
            begin
            vl:=LeftStr(v,Pos(':',v)-1);
            vr:=RightStr(v,Length(v)-Pos(':',v));
            v:=':';
            end
          else
            begin
            vl:='';
            vr:='';
            v:='';
            end;
          writeln(f,'    <TD align="right">');
          writeln(f,'      '+vl);
          writeln(f,'    </TD>');
          writeln(f,'    <TD align="center">');
          writeln(f,'      '+v);
          writeln(f,'    </TD>');
          writeln(f,'    <TD align="left">');
          writeln(f,'      '+vr);
          writeln(f,'    </TD>');
          writeln(f,'  </TR>');
          end;
        for j:=2 to SPZap do
          begin
          writeln(f,'  <TR>');
          writeln(f,'    <TD align="left">');
          writeln(f,'      '+Seznam[Rozpis[i,j,1]]);
          writeln(f,'    </TD>');
          writeln(f,'    <TD align="center">');
          writeln(f,'      -');
          writeln(f,'    </TD>');
          writeln(f,'    <TD align="left">');
          writeln(f,'      '+Seznam[Rozpis[i,j,2]]);
          writeln(f,'    </TD>');
          v:=Vysledek(Zapasy[Rozpis[i,j,1],Rozpis[i,j,2]],Zapasy[Rozpis[i,j,2],Rozpis[i,j,1]]);
          vl:=LeftStr(v,Pos(':',v)-1);
          vr:=RightStr(v,Length(v)-Pos(':',v));
          if v<>'' then
            begin
            vl:=LeftStr(v,Pos(':',v)-1);
            vr:=RightStr(v,Length(v)-Pos(':',v));
            v:=':';
            end
          else
            begin
            vl:='';
            vr:='';
            v:='';
            end;
          writeln(f,'    <TD align="right">');
          writeln(f,'      '+vl);
          writeln(f,'    </TD>');
          writeln(f,'    <TD align="center">');
          writeln(f,'      '+v);
          writeln(f,'    </TD>');
          writeln(f,'    <TD align="left">');
          writeln(f,'      '+vr);
          writeln(f,'    </TD>');
          writeln(f,'  </TR>');
          end;
        end;
      writeln(f,'</TABLE>');
      writeln(f,'</FONT>');
      end;
    3:begin
      writeln(f,'<FONT size="3">');
      writeln(f,'<TABLE border="0" cellspacing="5" cellpadding="1">');
      writeln(f,'  <TR height="35">');
      writeln(f,'    <TD width="30">');
      writeln(f,'    </TD>');
      writeln(f,'    <TD width="220">');
      writeln(f,'      NAZEV');
      writeln(f,'    </TD>');
      writeln(f,'    <TD align="center" width="50">');
      writeln(f,'      zap.');
      writeln(f,'    </TD>');
      writeln(f,'    <TD align="center" width="30">');
      writeln(f,'      vit.');
      writeln(f,'    </TD>');
      writeln(f,'    <TD align="center" width="30">');
      writeln(f,'      rem.');
      writeln(f,'    </TD>');
      writeln(f,'    <TD align="center" width="30">');
      writeln(f,'      por.');
      writeln(f,'    </TD>');
      writeln(f,'    <TD align="center" width="85" colspan="3">');
      writeln(f,'      skore');
      writeln(f,'    </TD>');
      writeln(f,'    <TD align="center" width="50">');
      writeln(f,'      BODY');
      writeln(f,'    </TD>');
      writeln(f,'  </TR>');
      for i:=1 to SPocet do
        begin
        writeln(f,'  <TR>');
        writeln(f,'    <TD align="center">');
        if not(TabHTML[i].dodatek) then
          writeln(f,'      '+IntToStr(i)+'.');
        writeln(f,'    </TD>');
        writeln(f,'    <TD align="left">');
        writeln(f,'      '+TabHTML[i].tym);
        writeln(f,'    </TD>');
        writeln(f,'    <TD align="center">');
        writeln(f,'      '+IntToStr(TabHTML[i].pv+TabHTML[i].pr+TabHTML[i].pp));
        writeln(f,'    </TD>');
        writeln(f,'    <TD align="center">');
        writeln(f,'      '+IntToStr(TabHTML[i].pv));
        writeln(f,'    </TD>');
        writeln(f,'    <TD align="center">');
        writeln(f,'      '+IntToStr(TabHTML[i].pr));
        writeln(f,'    </TD>');
        writeln(f,'    <TD align="center">');
        writeln(f,'      '+IntToStr(TabHTML[i].pp));
        writeln(f,'    </TD>');
        writeln(f,'    <TD align="right" width="40">');
        writeln(f,'      '+IntToStr(TabHTML[i].bv));
        writeln(f,'    </TD>');
        writeln(f,'    <TD align="center" width="5">');
        writeln(f,'      :');
        writeln(f,'    </TD>');
        writeln(f,'    <TD align="left" width="40">');
        writeln(f,'      '+IntToStr(TabHTML[i].bo));
        writeln(f,'    </TD>');
        writeln(f,'    <TD align="center">');
        writeln(f,'      '+IntToStr(TabHTML[i].body));
        writeln(f,'    </TD>');
        writeln(f,'  </TR>');
        end;
      writeln(f,'</TABLE>');
      writeln(f,'</FONT>');
      end;
    4:begin
      writeln(f,'<font face="Courier" size="3">');
      writeln(f,'<table border="1">');
      writeln(f,'  <tr>');
      writeln(f,'    <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>');
      for i:=1 to SPocet do
        writeln(f,'    <td>&nbsp;'+leftstr(Seznam[i],10)+'</td>');
      writeln(f,'  </tr>');
      for i:=1 to SPocet do
        begin
        writeln(f,'  <tr>');
        writeln(f,'    <td>&nbsp;'+leftstr(Seznam[i],20)+'</td>');
        for j:=1 to SPocet do
          if i<>j then
            writeln(f,'    <td align="center">&nbsp;'+Vysledek(Zapasy[i,j],Zapasy[j,i])+'</td>')
          else
            writeln(f,'    <td>&nbsp;xxxxxxxxxx&nbsp;</td>');
        writeln(f,'  </tr>');
        end;
      writeln(f,'</table>');
      writeln(f,'</font>');
      end;
    end;
  writeln(f);
  writeln(f,'<!-- EndSource             -->');
  CloseFile(f);
  end;
end;

procedure TForm1.N1Tmy1Click(Sender: TObject);
begin
Label1Click(nil);
Label1.Font.Color:=clNavy;
end;

procedure TForm1.N2Rozpis1Click(Sender: TObject);
begin
Label2Click(nil);
Label2.Font.Color:=clNavy;
end;

procedure TForm1.N31Click(Sender: TObject);
begin
Label3Click(nil);
Label3.Font.Color:=clNavy;
end;

procedure TForm1.N41Click(Sender: TObject);
begin
Label4Click(nil);
Label4.Font.Color:=clNavy;
end;

procedure TForm1.N51Click(Sender: TObject);
begin
Label5Click(nil);
Label5.Font.Color:=clNavy;
end;

procedure TForm1.N61Click(Sender: TObject);
begin
Label6Click(nil);
Label6.Font.Color:=clNavy;
end;

procedure TForm1.N71Click(Sender: TObject);
begin
Label7Click(nil);
Label7.Font.Color:=clNavy;
end;

procedure TForm1.CheckBox4Click(Sender: TObject);
begin
Label6Click(nil);
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
Label5Click(nil);
end;

end.

