unit u_help;

interface

uses
  SysUtils, Types, Classes, Variants, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QComCtrls;

type
  THelpForm = class(TForm)
    TabControl1: TTabControl;
    Label1: TLabel;
    Memo1: TMemo;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TabControl1Change(Sender: TObject);
  private
    { Private declarations }
    texthelpfile:string;
    procedure ReadHelp(index: integer);
  public
    { Public declarations }
    procedure ShowHelp(index: integer);
  end;

var
  HelpForm: THelpForm;

implementation

{$R *.xfm}

procedure THelpForm.Button1Click(Sender: TObject);
begin
Close;
end;

procedure THelpForm.FormCreate(Sender: TObject);
var f:textfile;
    s:string;
begin
Label1.Caption:='Simple Help System'+Chr(10)+'(c) PostWare 2001'+Chr(10)+'postware@postak.com'+Chr(10)+'http://kylix.postak.com';

AssignFile(f,'./file.shs');
Reset(f);
readln(f,texthelpfile);
CloseFile(f);

AssignFile(f,texthelpfile);
Reset(f);
repeat
  readln(f,s);
until s='<THEMES>';
readln(f,s);
TabControl1.Tabs[0].Caption:=s;
readln(f,s);
while s<>'</THEMES>' do
  begin
  TabControl1.Tabs.Add(s);
  readln(f,s);
  end;
CloseFile(f);

TabControl1.TabIndex:=0;
ReadHelp(0);
end;

procedure THelpForm.TabControl1Change(Sender: TObject);
begin
ReadHelp(TabControl1.TabIndex);
end;

procedure THelpForm.ReadHelp(index: integer);
var f:textfile;
    s,ts,te:string;
    i:integer;
begin
Memo1.Hide;
Memo1.Clear;
AssignFile(f,texthelpfile);
Reset(f);
repeat
  readln(f,s);
until s='<THEMES>';
for i:=0 to index do
  readln(f,s);
ts:='<'+s+'>';
te:='</'+s+'>';
repeat
  readln(f,s);
until s=ts;
repeat
  readln(f,s);
  if s<>te then
    begin
    Memo1.Lines.Add(s);
    end;
until s=te;
Memo1.Lines.Add('');
CloseFile(f);
Memo1.SelStart:=0;
Memo1.Show;
end;

procedure THelpForm.ShowHelp(index: integer);
begin
if index<>-1 then
  begin
  TabControl1.TabIndex:=index;
  ReadHelp(index);
  end;
HelpForm.ShowModal;
end;

end.
